## obs-studio 30.0.2+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16...3.25)

legacy_check()

set(obs-websocket_VERSION 5.3.4)
set(OBS_WEBSOCKET_RPC_VERSION 1)

option(ENABLE_WEBSOCKET "Enable building OBS with websocket plugin" ON)
if(NOT ENABLE_WEBSOCKET)
  target_disable(obs-websocket)
  return()
endif()

# Find Qt
find_qt(COMPONENTS Core Widgets Svg Network)

# Find nlohmann JSON
find_package(nlohmann_json 3 REQUIRED)

# Find qrcodegencpp
set(CMAKE_FIND_PACKAGE_PREFER_CONFIG ON)
find_package(qrcodegencpp REQUIRED)
set(CMAKE_FIND_PACKAGE_PREFER_CONFIG OFF)

# Find WebSocket++
find_package(Websocketpp 0.8 REQUIRED)

# Find Asio
find_package(Asio 1.12.1 REQUIRED)

add_library(obs-websocket MODULE)
add_library(OBS::websocket ALIAS obs-websocket)

target_sources(obs-websocket PRIVATE)

target_sources(
  obs-websocket
  PRIVATE src/obs-websocket.cpp
          src/obs-websocket.h
          src/Config.cpp
          src/Config.h
          lib/obs-websocket-api.h
          src/forms/ConnectInfo.cpp
          src/forms/ConnectInfo.h
          src/forms/resources.qrc
          src/forms/SettingsDialog.cpp
          src/forms/SettingsDialog.h
          src/WebSocketApi.cpp
          src/WebSocketApi.h)

target_sources(
  obs-websocket
  PRIVATE src/websocketserver/WebSocketServer.cpp
          src/websocketserver/WebSocketServer_Protocol.cpp
          src/websocketserver/WebSocketServer.h
          src/websocketserver/rpc/WebSocketSession.h
          src/websocketserver/types/WebSocketCloseCode.h
          src/websocketserver/types/WebSocketOpCode.h)

target_sources(
  obs-websocket
  PRIVATE src/eventhandler/EventHandler.cpp
          src/eventhandler/EventHandler.h
          src/eventhandler/EventHandler_Config.cpp
          src/eventhandler/EventHandler_General.cpp
          src/eventhandler/EventHandler_Filters.cpp
          src/eventhandler/EventHandler_Inputs.cpp
          src/eventhandler/EventHandler_MediaInputs.cpp
          src/eventhandler/EventHandler_Outputs.cpp
          src/eventhandler/EventHandler_Scenes.cpp
          src/eventhandler/EventHandler_SceneItems.cpp
          src/eventhandler/EventHandler_Transitions.cpp
          src/eventhandler/EventHandler_Ui.cpp
          src/eventhandler/types/EventSubscription.h)

target_sources(
  obs-websocket
  PRIVATE src/requesthandler/RequestBatchHandler.cpp
          src/requesthandler/RequestBatchHandler.h
          src/requesthandler/RequestHandler.cpp
          src/requesthandler/RequestHandler.h
          src/requesthandler/RequestHandler_Config.cpp
          src/requesthandler/RequestHandler_Filters.cpp
          src/requesthandler/RequestHandler_General.cpp
          src/requesthandler/RequestHandler_Inputs.cpp
          src/requesthandler/RequestHandler_MediaInputs.cpp
          src/requesthandler/RequestHandler_Outputs.cpp
          src/requesthandler/RequestHandler_Sources.cpp
          src/requesthandler/RequestHandler_Record.cpp
          src/requesthandler/RequestHandler_Scenes.cpp
          src/requesthandler/RequestHandler_SceneItems.cpp
          src/requesthandler/RequestHandler_Stream.cpp
          src/requesthandler/RequestHandler_Transitions.cpp
          src/requesthandler/RequestHandler_Ui.cpp
          src/requesthandler/rpc/Request.cpp
          src/requesthandler/rpc/Request.h
          src/requesthandler/rpc/RequestBatchRequest.cpp
          src/requesthandler/rpc/RequestBatchRequest.h
          src/requesthandler/rpc/RequestResult.cpp
          src/requesthandler/rpc/RequestResult.h
          src/requesthandler/types/RequestStatus.h
          src/requesthandler/types/RequestBatchExecutionType.h)

target_sources(
  obs-websocket
  PRIVATE src/utils/Compat.cpp
          src/utils/Compat.h
          src/utils/Crypto.cpp
          src/utils/Crypto.h
          src/utils/Json.cpp
          src/utils/Json.h
          src/utils/Obs.cpp
          src/utils/Obs.h
          src/utils/Obs_ActionHelper.cpp
          src/utils/Obs_ArrayHelper.cpp
          src/utils/Obs_NumberHelper.cpp
          src/utils/Obs_ObjectHelper.cpp
          src/utils/Obs_StringHelper.cpp
          src/utils/Obs_SearchHelper.cpp
          src/utils/Obs_VolumeMeter.cpp
          src/utils/Obs_VolumeMeter.h
          src/utils/Obs_VolumeMeter_Helpers.h
          src/utils/Platform.cpp
          src/utils/Platform.h
          src/utils/Utils.h)

configure_file(src/plugin-macros.h.in plugin-macros.generated.h)
target_sources(obs-websocket PRIVATE plugin-macros.generated.h)

target_compile_definitions(
  obs-websocket PRIVATE ASIO_STANDALONE $<$<BOOL:${PLUGIN_TESTS}>:PLUGIN_TESTS>
                        $<$<PLATFORM_ID:Windows>:_WEBSOCKETPP_CPP11_STL_> $<$<PLATFORM_ID:Windows>:_WIN32_WINNT=0x0603>)

target_compile_options(
  obs-websocket
  PRIVATE
    $<$<PLATFORM_ID:Windows>:/wd4267>
    $<$<PLATFORM_ID:Windows>:/wd4996>
    $<$<PLATFORM_ID:Darwin,Linux,FreeBSD>:-Wall>
    $<$<COMPILE_LANG_AND_ID:CXX,GNU,AppleClang,Clang>:-Wno-error=float-conversion;-Wno-error=shadow>
    $<$<COMPILE_LANG_AND_ID:CXX,GNU>:-Wno-error=format-overflow;-Wno-error=int-conversion;-Wno-error=comment>
    $<$<COMPILE_LANG_AND_ID:CXX,AppleClang,Clang>:-Wno-error=null-pointer-subtraction;-Wno-error=deprecated-declarations;-Wno-error=implicit-int-conversion;-Wno-error=shorten-64-to-32;-Wno-comma;-Wno-quoted-include-in-framework-header>
)

target_link_libraries(
  obs-websocket
  PRIVATE OBS::libobs
          OBS::frontend-api
          Qt::Core
          Qt::Widgets
          Qt::Svg
          Qt::Network
          nlohmann_json::nlohmann_json
          Websocketpp::Websocketpp
          Asio::Asio
          qrcodegencpp::qrcodegencpp)

set_target_properties_obs(
  obs-websocket
  PROPERTIES FOLDER plugins
             PREFIX ""
             AUTOMOC ON
             AUTOUIC ON
             AUTORCC ON)

if(OS_WINDOWS)
  set_property(
    TARGET obs-websocket
    APPEND
    PROPERTY AUTORCC_OPTIONS --format-version 1)

  target_link_options(obs-websocket PRIVATE /IGNORE:4099)
endif()

=== deps/CMakeLists.txt ===
if(OS_WINDOWS)
  if(NOT MINGW)
    add_subdirectory(w32-pthreads)
  endif()
  add_subdirectory(ipc-util)
endif()

add_subdirectory(blake2)
add_subdirectory(glad)
add_subdirectory(media-playback)
add_subdirectory(file-updater)
add_subdirectory(obs-scripting)
add_subdirectory(opts-parser)
add_subdirectory(libcaption)
add_subdirectory(uthash)
add_subdirectory(happy-eyeballs)

=== libobs-opengl/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.22...3.25)

legacy_check()

add_library(libobs-opengl SHARED)
add_library(OBS::libobs-opengl ALIAS libobs-opengl)

if(NOT TARGET OBS::glad)
  add_subdirectory("${CMAKE_SOURCE_DIR}/deps/glad" "${CMAKE_BINARY_DIR}/deps/glad")
endif()

target_sources(
  libobs-opengl
  PRIVATE gl-helpers.c
          gl-helpers.h
          gl-indexbuffer.c
          gl-shader.c
          gl-shaderparser.c
          gl-shaderparser.h
          gl-stagesurf.c
          gl-subsystem.c
          gl-subsystem.h
          gl-texture2d.c
          gl-texture3d.c
          gl-texturecube.c
          gl-vertexbuffer.c
          gl-zstencil.c)

target_link_libraries(libobs-opengl PRIVATE OBS::libobs OBS::glad)

if(OS_WINDOWS)
  configure_file(cmake/windows/obs-module.rc.in libobs-opengl.rc)

  target_sources(libobs-opengl PRIVATE gl-windows.c libobs-opengl.rc)
elseif(OS_MACOS)
  find_library(COCOA Cocoa)
  find_library(IOSURF IOSurface)

  target_sources(libobs-opengl PRIVATE gl-cocoa.m)
  target_compile_definitions(libobs-opengl PRIVATE GL_SILENCE_DEPRECATION)
  target_compile_options(libobs-opengl PRIVATE -Wno-strict-prototypes)

  target_link_libraries(libobs-opengl PRIVATE ${COCOA} ${IOSURF})
elseif(OS_LINUX OR OS_FREEBSD)
  find_package(X11 REQUIRED)
  find_package(
    xcb
    COMPONENTS xcb
    REQUIRED)
  find_package(x11-xcb REQUIRED)

  target_sources(libobs-opengl PRIVATE gl-egl-common.c gl-nix.c gl-x11-egl.c)
  target_link_libraries(libobs-opengl PRIVATE xcb::xcb X11::x11-xcb)

  if(ENABLE_WAYLAND)
    find_package(
      OpenGL
      COMPONENTS EGL
      REQUIRED)

    find_package(Wayland REQUIRED)

    target_sources(libobs-opengl PRIVATE gl-wayland-egl.c)
    target_link_libraries(libobs-opengl PRIVATE OpenGL::EGL Wayland::EGL)
  endif()

endif()

target_enable_feature(libobs "OpenGL renderer")

set_target_properties_obs(
  libobs-opengl
  PROPERTIES FOLDER core
             VERSION 0
             PREFIX ""
             SOVERSION "${OBS_VERSION_MAJOR}")

=== libobs-winrt/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.24...3.25)

legacy_check()

add_library(libobs-winrt-headers INTERFACE)
add_library(OBS::winrt-headers ALIAS libobs-winrt-headers)

target_sources(libobs-winrt-headers INTERFACE winrt-capture.h)
target_include_directories(libobs-winrt-headers INTERFACE "${CMAKE_CURRENT_SOURCE_DIR}")

add_library(libobs-winrt MODULE)
add_library(OBS::libobs-winrt ALIAS libobs-winrt)

target_sources(libobs-winrt PRIVATE winrt-capture.cpp winrt-capture.h winrt-dispatch.cpp winrt-dispatch.h)

target_precompile_headers(
  libobs-winrt
  PRIVATE
  <d3d11.h>
  <DispatcherQueue.h>
  <dwmapi.h>
  <obs-module.h>
  <util/windows/ComPtr.hpp>
  <Windows.Graphics.Capture.Interop.h>
  <winrt/Windows.Foundation.Metadata.h>
  <winrt/Windows.Graphics.Capture.h>
  <winrt/Windows.System.h>)

target_link_libraries(libobs-winrt PRIVATE OBS::libobs OBS::COMutils Dwmapi windowsapp)

# cmake-format: off
set_target_properties_obs(libobs-winrt PROPERTIES FOLDER core)
# cmake-format: on

=== libobs/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.22...3.25)

legacy_check()

# cmake-format: off
add_library(libobs-version STATIC EXCLUDE_FROM_ALL)
add_library(OBS::libobs-version ALIAS libobs-version)
# cmake-format: on
configure_file(obsversion.c.in obsversion.c @ONLY)
target_sources(libobs-version PRIVATE obsversion.c obsversion.h)
set_property(TARGET libobs-version PROPERTY FOLDER core)

add_library(libobs SHARED)
add_library(OBS::libobs ALIAS libobs)

find_package(Threads REQUIRED)
find_package(FFmpeg REQUIRED avformat avutil swscale swresample OPTIONAL_COMPONENTS avcodec)
find_package(ZLIB REQUIRED)

if(ENABLE_UI)
  find_qt(COMPONENTS Core)
endif()

find_package(jansson REQUIRED)
add_subdirectory("${CMAKE_SOURCE_DIR}/deps/libcaption" "${CMAKE_BINARY_DIR}/deps/libcaption")
add_subdirectory("${CMAKE_SOURCE_DIR}/deps/uthash" "${CMAKE_BINARY_DIR}/deps/uthash")

target_sources(
  libobs
  PRIVATE # cmake-format: sortable
          $<$<BOOL:${ENABLE_HEVC}>:obs-hevc.c>
          $<$<BOOL:${ENABLE_HEVC}>:obs-hevc.h>
          obs-audio-controls.c
          obs-audio-controls.h
          obs-audio.c
          obs-avc.c
          obs-avc.h
          obs-data.c
          obs-data.h
          obs-defs.h
          obs-display.c
          obs-encoder.c
          obs-encoder.h
          obs-ffmpeg-compat.h
          obs-hotkey-name-map.c
          obs-hotkey.c
          obs-hotkey.h
          obs-hotkeys.h
          obs-interaction.h
          obs-internal.h
          obs-missing-files.c
          obs-missing-files.h
          obs-module.c
          obs-module.h
          obs-nal.c
          obs-nal.h
          obs-output-delay.c
          obs-output.c
          obs-output.h
          obs-properties.c
          obs-properties.h
          obs-scene.c
          obs-scene.h
          obs-service.c
          obs-service.h
          obs-source-deinterlace.c
          obs-source-transition.c
          obs-source.c
          obs-source.h
          obs-ui.h
          obs-video-gpu-encode.c
          obs-video.c
          obs-view.c
          obs.c
          obs.h
          obs.hpp)

target_sources(
  libobs
  PRIVATE # cmake-format: sortable
          util/array-serializer.c
          util/array-serializer.h
          util/base.c
          util/base.h
          util/bitstream.c
          util/bitstream.h
          util/bmem.c
          util/bmem.h
          util/c99defs.h
          util/cf-lexer.c
          util/cf-lexer.h
          util/cf-parser.c
          util/cf-parser.h
          util/circlebuf.h
          util/config-file.c
          util/config-file.h
          util/crc32.c
          util/crc32.h
          util/curl/curl-helper.h
          util/darray.h
          util/dstr.c
          util/dstr.h
          util/file-serializer.c
          util/file-serializer.h
          util/lexer.c
          util/lexer.h
          util/pipe.h
          util/platform.c
          util/platform.h
          util/profiler.c
          util/profiler.h
          util/profiler.hpp
          util/serializer.h
          util/sse-intrin.h
          util/task.c
          util/task.h
          util/text-lookup.c
          util/text-lookup.h
          util/threading.h
          util/utf8.c
          util/utf8.h
          util/uthash.h
          util/util.hpp
          util/util_uint128.h
          util/util_uint64.h)

target_sources(
  libobs
  PRIVATE # cmake-format: sortable
          util/simde/check.h
          util/simde/debug-trap.h
          util/simde/hedley.h
          util/simde/simde-align.h
          util/simde/simde-arch.h
          util/simde/simde-common.h
          util/simde/simde-constify.h
          util/simde/simde-detect-clang.h
          util/simde/simde-diagnostic.h
          util/simde/simde-features.h
          util/simde/simde-math.h
          util/simde/x86/mmx.h
          util/simde/x86/sse.h
          util/simde/x86/sse2.h)

target_sources(
  libobs
  PRIVATE # cmake-format: sortable
          callback/calldata.c
          callback/calldata.h
          callback/decl.c
          callback/decl.h
          callback/proc.c
          callback/proc.h
          callback/signal.c
          callback/signal.h)

target_sources(
  libobs
  PRIVATE # cmake-format: sortable
          media-io/audio-io.c
          media-io/audio-io.h
          media-io/audio-math.h
          media-io/audio-resampler-ffmpeg.c
          media-io/audio-resampler.h
          media-io/format-conversion.c
          media-io/format-conversion.h
          media-io/frame-rate.h
          media-io/media-io-defs.h
          media-io/media-remux.c
          media-io/media-remux.h
          media-io/video-fourcc.c
          media-io/video-frame.c
          media-io/video-frame.h
          media-io/video-io.c
          media-io/video-io.h
          media-io/video-matrices.c
          media-io/video-scaler-ffmpeg.c
          media-io/video-scaler.h)

target_sources(
  libobs
  PRIVATE # cmake-format: sortable
          graphics/axisang.c
          graphics/axisang.h
          graphics/bounds.c
          graphics/bounds.h
          graphics/device-exports.h
          graphics/effect-parser.c
          graphics/effect-parser.h
          graphics/effect.c
          graphics/effect.h
          graphics/graphics-ffmpeg.c
          graphics/graphics-imports.c
          graphics/graphics-internal.h
          graphics/graphics.c
          graphics/graphics.h
          graphics/half.h
          graphics/image-file.c
          graphics/image-file.h
          graphics/input.h
          graphics/libnsgif/libnsgif.c
          graphics/libnsgif/libnsgif.h
          graphics/math-defs.h
          graphics/math-extra.c
          graphics/math-extra.h
          graphics/matrix3.c
          graphics/matrix3.h
          graphics/matrix4.c
          graphics/matrix4.h
          graphics/plane.c
          graphics/plane.h
          graphics/quat.c
          graphics/quat.h
          graphics/shader-parser.c
          graphics/shader-parser.h
          graphics/srgb.h
          graphics/texture-render.c
          graphics/vec2.c
          graphics/vec2.h
          graphics/vec3.c
          graphics/vec3.h
          graphics/vec4.c
          graphics/vec4.h)

target_compile_features(libobs PUBLIC cxx_std_17)
target_compile_definitions(
  libobs
  PRIVATE IS_LIBOBS
  PUBLIC $<BUILD_INTERFACE:$<$<BOOL:${ENABLE_HEVC}>:ENABLE_HEVC>>
         $<BUILD_INTERFACE:$<$<BOOL:${ENABLE_FFMPEG_MUX_DEBUG}>:SHOW_SUBPROCESSES>>)

target_link_libraries(
  libobs
  PRIVATE OBS::caption
          OBS::uthash
          OBS::libobs-version
          FFmpeg::avcodec
          FFmpeg::avformat
          FFmpeg::avutil
          FFmpeg::swscale
          FFmpeg::swresample
          jansson::jansson
          ZLIB::ZLIB
  PUBLIC Threads::Threads)

if(OS_WINDOWS)
  include(cmake/os-windows.cmake)
elseif(OS_MACOS)
  include(cmake/os-macos.cmake)
elseif(OS_LINUX)
  include(cmake/os-linux.cmake)
elseif(OS_FREEBSD)
  include(cmake/os-freebsd.cmake)
endif()

configure_file(obsconfig.h.in "${CMAKE_BINARY_DIR}/config/obsconfig.h" @ONLY)
target_include_directories(libobs PUBLIC "$<BUILD_INTERFACE:${CMAKE_BINARY_DIR}/config>"
                                         "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>")
target_compile_definitions(libobs PUBLIC HAVE_OBSCONFIG_H)

set(public_headers
    # cmake-format: sortable
    callback/calldata.h
    callback/decl.h
    callback/proc.h
    callback/signal.h
    graphics/axisang.h
    graphics/bounds.h
    graphics/effect-parser.h
    graphics/effect.h
    graphics/graphics.h
    graphics/image-file.h
    graphics/input.h
    graphics/libnsgif/libnsgif.h
    graphics/math-defs.h
    graphics/math-extra.h
    graphics/matrix3.h
    graphics/matrix4.h
    graphics/plane.h
    graphics/quat.h
    graphics/shader-parser.h
    graphics/srgb.h
    graphics/vec2.h
    graphics/vec3.h
    graphics/vec4.h
    media-io/audio-io.h
    media-io/audio-math.h
    media-io/audio-resampler.h
    media-io/format-conversion.h
    media-io/frame-rate.h
    media-io/media-io-defs.h
    media-io/media-remux.h
    media-io/video-frame.h
    media-io/video-io.h
    media-io/video-scaler.h
    obs-audio-controls.h
    obs-avc.h
    obs-config.h
    obs-data.h
    obs-defs.h
    obs-encoder.h
    obs-hotkey.h
    obs-hotkeys.h
    obs-interaction.h
    obs-missing-files.h
    obs-module.h
    obs-nal.h
    obs-nix-platform.h
    obs-output.h
    obs-properties.h
    obs-service.h
    obs-source.h
    obs-ui.h
    obs.h
    obs.hpp
    util/AlignedNew.hpp
    util/apple/cfstring-utils.h
    util/array-serializer.h
    util/base.h
    util/bitstream.h
    util/bmem.h
    util/c99defs.h
    util/cf-lexer.h
    util/cf-parser.h
    util/circlebuf.h
    util/config-file.h
    util/crc32.h
    util/darray.h
    util/dstr.h
    util/dstr.hpp
    util/file-serializer.h
    util/lexer.h
    util/pipe.h
    util/platform.h
    util/profiler.h
    util/profiler.hpp
    util/serializer.h
    util/simde/check.h
    util/simde/debug-trap.h
    util/simde/hedley.h
    util/simde/simde-align.h
    util/simde/simde-arch.h
    util/simde/simde-common.h
    util/simde/simde-constify.h
    util/simde/simde-detect-clang.h
    util/simde/simde-diagnostic.h
    util/simde/simde-features.h
    util/simde/simde-math.h
    util/simde/x86/mmx.h
    util/simde/x86/sse.h
    util/simde/x86/sse2.h
    util/sse-intrin.h
    util/task.h
    util/text-lookup.h
    util/threading-posix.h
    util/threading-windows.h
    util/threading.h
    util/uthash.h
    util/util.hpp
    util/util_uint128.h
    util/util_uint64.h
    util/windows/ComPtr.hpp
    util/windows/CoTaskMemPtr.hpp
    util/windows/device-enum.h
    util/windows/HRError.hpp
    util/windows/win-registry.h
    util/windows/win-version.h
    util/windows/window-helpers.h
    util/windows/WinHandle.hpp)

if(ENABLE_HEVC)
  list(APPEND public_headers obs-hevc.h)
endif()

# cmake-format: off
set_property(TARGET libobs APPEND PROPERTY OBS_PUBLIC_HEADERS ${public_headers})

set_target_properties_obs(
  libobs
  PROPERTIES FOLDER core
             VERSION 0
             SOVERSION "${OBS_VERSION_MAJOR}")
# cmake-format: on

target_export(libobs)

=== UI/obs-frontend-api/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.22...3.25)

legacy_check()

add_library(obs-frontend-api SHARED)
add_library(OBS::frontend-api ALIAS obs-frontend-api)

target_sources(obs-frontend-api PRIVATE obs-frontend-api.h obs-frontend-api.cpp obs-frontend-internal.hpp)

target_link_libraries(obs-frontend-api PRIVATE OBS::libobs)

target_include_directories(obs-frontend-api PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>")

if(OS_WINDOWS)
  configure_file(cmake/windows/obs-module.rc.in obs-frontend-api.rc)
  target_sources(obs-frontend-api PRIVATE obs-frontend-api.rc)
elseif(OS_MACOS)
  set_target_properties(obs-frontend-api PROPERTIES SOVERSION 1)
endif()

set_target_properties_obs(obs-frontend-api PROPERTIES FOLDER frontend PREFIX "" PUBLIC_HEADER obs-frontend-api.h)

target_export(obs-frontend-api)

=== UI/xdg-data/CMakeLists.txt ===
if(NOT DEFINED APPDATA_RELEASE_DATE)
  if(EXISTS "${CMAKE_SOURCE_DIR}/.git")
    execute_process(
      COMMAND git log --tags -1 --pretty=%cd --date=short
      OUTPUT_VARIABLE APPDATA_RELEASE_DATE
      WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
      OUTPUT_STRIP_TRAILING_WHITESPACE)
  else()
    file(TIMESTAMP "${CMAKE_SOURCE_DIR}/CMakeLists.txt" APPDATA_RELEASE_DATE "%Y-%m-%d")
  endif()
endif()

if(NOT DEFINED GIT_HASH)
  if(EXISTS "${CMAKE_SOURCE_DIR}/.git")
    execute_process(
      COMMAND git rev-parse HEAD
      OUTPUT_VARIABLE GIT_HASH
      WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
      OUTPUT_STRIP_TRAILING_WHITESPACE)
  else()
    set(GIT_HASH "master")
  endif()
endif()

configure_file(com.obsproject.Studio.appdata.xml.in com.obsproject.Studio.appdata.xml)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/com.obsproject.Studio.appdata.xml
        DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/metainfo)

install(FILES com.obsproject.Studio.desktop DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)

install(
  FILES icons/obs-logo-128.png
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/128x128/apps
  RENAME com.obsproject.Studio.png)

install(
  FILES icons/obs-logo-256.png
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/256x256/apps
  RENAME com.obsproject.Studio.png)

install(
  FILES icons/obs-logo-512.png
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/512x512/apps
  RENAME com.obsproject.Studio.png)

install(
  FILES icons/obs-logo-scalable.svg
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/scalable/apps
  RENAME com.obsproject.Studio.svg)

=== deps/file-updater/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.22...3.25)

find_package(CURL REQUIRED)

add_library(file-updater INTERFACE)
add_library(OBS::file-updater ALIAS file-updater)

target_sources(file-updater INTERFACE file-updater/file-updater.c file-updater/file-updater.h)

target_link_libraries(file-updater INTERFACE CURL::libcurl $<$<PLATFORM_ID:Windows>:OBS::w32-pthreads>)

target_include_directories(file-updater INTERFACE "${CMAKE_CURRENT_SOURCE_DIR}")

=== deps/happy-eyeballs/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.22...3.25)

add_library(happy-eyeballs INTERFACE)
add_library(OBS::happy-eyeballs ALIAS happy-eyeballs)

target_sources(happy-eyeballs INTERFACE happy-eyeballs.c happy-eyeballs.h)

target_include_directories(happy-eyeballs INTERFACE ${CMAKE_CURRENT_SOURCE_DIR})

target_link_libraries(happy-eyeballs INTERFACE OBS::libobs)

if(OS_WINDOWS)
  target_link_libraries(happy-eyeballs INTERFACE OBS::w32-pthreads)
endif()

set_target_properties(happy-eyeballs PROPERTIES FOLDER deps)

=== deps/ipc-util/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.24...3.25)

# cmake-format: off
add_library(ipc-util STATIC EXCLUDE_FROM_ALL)
# cmake-format: on
add_library(OBS::ipc-util ALIAS ipc-util)

target_sources(ipc-util PRIVATE ipc-util/pipe.h)
target_include_directories(ipc-util PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}")

target_sources(ipc-util PRIVATE ipc-util/pipe-windows.c ipc-util/pipe-windows.h)
target_compile_options(ipc-util PRIVATE $<IF:$<CONFIG:Debug>,/MTd,/MT> /Zl)

set_target_properties(ipc-util PROPERTIES FOLDER deps POSITION_INDEPENDENT_CODE ON)

=== deps/json11/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.22...3.25)

add_library(json11 INTERFACE)
add_library(OBS::json11 ALIAS json11)

target_include_directories(json11 INTERFACE "${CMAKE_CURRENT_SOURCE_DIR}")
target_compile_options(json11 INTERFACE $<$<COMPILE_LANG_AND_ID:CXX,AppleClang,Clang>:-Wno-unqualified-std-cast-call>)

target_sources(json11 INTERFACE json11.cpp json11.hpp)

=== deps/libcaption/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.22...3.25)

add_library(caption STATIC EXCLUDE_FROM_ALL )
add_library(OBS::caption ALIAS caption)

target_sources(
  caption
  PRIVATE src/caption.c
          src/cea708.c
          src/eia608.c
          src/eia608_charmap.c
          src/eia608_from_utf8.c
          src/mpeg.c
          src/srt.c
          src/scc.c
          src/utf8.c
          src/xds.c
          caption/eia608.h
          caption/eia608_charmap.h
          caption/cea708.h
          caption/mpeg.h
          caption/scc.h
          caption/utf8.h
  PUBLIC caption/caption.h)

target_compile_definitions(caption PRIVATE __STDC_CONSTANT_MACROS $<$<CXX_COMPILER_ID:MSVC>:_CRT_SECURE_NO_WARNINGS>)

target_compile_options(
  caption
  PRIVATE "$<$<CXX_COMPILER_ID:Clang,AppleClang,GNU>:-Wno-unused-but-set-parameter;-Wno-comma;-Wno-strict-prototypes>")

target_include_directories(
  caption
  PRIVATE caption
  PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}")

set_target_properties(caption PROPERTIES FOLDER deps POSITION_INDEPENDENT_CODE ON)

=== debian/changelog ===
obs-studio (30.0.2+dfsg-3build1) noble; urgency=high

  * No change rebuild against libqt6core6t64, libqt6gui6t64,
    libqt6network6t64, libqt6widgets6t64, libqt6xml6t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 08 Apr 2024 16:46:38 +0200

obs-studio (30.0.2+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Fix build on 32bit time64_t archs. Thanks to Gianfranco Costamagna.
    (Closes: #1067494)
  * linux-v4l2: Save device by ID or path to make webcam ordering persistent
    (to support having multiple in the system). Fixes upstream bug 3003.
  * Add simple autopkgtest that just calls obs --help and --version

 -- Benjamin Drung <bdrung@debian.org>  Sun, 31 Mar 2024 15:13:19 +0200

obs-studio (30.0.2+dfsg-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063224

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 01:39:16 +0000

obs-studio (30.0.2+dfsg-2) unstable; urgency=medium

  * d/rules: use $() for make variables
    (Closes: #1059799)
  * Add Unconditional B-D on luajit
    (dropping support for ppc64el)
    (Closes: #1051931)

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 09 Jan 2024 09:21:26 +0100

obs-studio (30.0.2+dfsg-1) unstable; urgency=medium

  * New upstream version 30.0.2+dfsg
    + Refresh patches

  * Add patch to disable building of removed modules
  * Features:
    + Disable WebRTC support for now
    + Enable pipewire support
  * Update B-Ds based on upstream documentation
    * Switch to Qt6
    * Mark libvpl as only available on amd64
  * Enable unit-tests
    + Ensure that testsuite sees the local libraries
    + Mark test-files as not-installed
  * Switch buildsystem to Ninja
  * Don't treat deprecated-declarations as errors
    (Closes: #1057587)
  * Update symbols file for libobs0
    + Add new symbols
    + Declare BD-Package
  * Make blhc ignore some false positives
  * Fix d/watch
  * Update copyright information
    + Update d/copyright
    + Exclude obs-studio.ico from licensecheck
    + Re-generate d/copyright

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Fri, 29 Dec 2023 18:29:25 +0100

=== debian/control ===
Source: obs-studio
Section: video
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Carl Fürstenberg <azatoth@gmail.com>,
 Sebastian Ramacher <sramacher@debian.org>,
 IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dh-sequence-python3,
 dh-sequence-scour,
 dpkg-dev (>= 1.22.5),
 gir1.2-rsvg-2.0,
 libasio-dev,
 libasound2-dev,
 libavcodec-dev,
 libavdevice-dev,
 libavfilter-dev,
 libavformat-dev,
 libavutil-dev,
 libcmocka-dev,
 libcurl4-gnutls-dev | libcurl-dev,
 libdbus-1-dev,
 libdrm-dev,
 libegl-dev,
 libffmpeg-nvenc-dev,
 libfontconfig-dev,
 libfreetype-dev,
 libglvnd-dev,
 libjack-jackd2-dev,
 libjansson-dev,
 libluajit-5.1-dev,
 libmbedtls-dev,
 libopengl-dev,
 libpci-dev,
 libpipewire-0.3-dev,
 libpulse-dev,
 libqrcodegencpp-dev,
 librist-dev,
 libsimde-dev,
 libspeexdsp-dev,
 libsrt-openssl-dev,
 libswresample-dev,
 libswscale-dev,
 libudev-dev,
 libv4l-dev,
 libva-dev,
 libvlc-dev,
 libvpl-dev [amd64],
 libwayland-dev,
 libwebsocketpp-dev,
 libx11-dev,
 libx11-xcb-dev,
 libx264-dev,
 libxcb-composite0-dev,
 libxcb-randr0-dev,
 libxcb-shm0-dev,
 libxcb-xfixes0-dev,
 libxcb-xinerama0-dev,
 libxcb-xinput-dev,
 libxcb1-dev,
 libxcomposite-dev,
 libxinerama-dev,
 libxkbcommon-dev,
 libxss-dev,
 ninja-build,
 nlohmann-json3-dev,
 python3-dev,
 python3-docutils,
 python3-gi-cairo,
 qt6-base-dev,
 qt6-base-private-dev,
 qt6-svg-dev,
 swig,
Standards-Version: 4.6.2
Homepage: https://obsproject.com
Vcs-Browser: https://salsa.debian.org/multimedia-team/obs-studio
Vcs-Git: https://salsa.debian.org/multimedia-team/obs-studio.git
Rules-Requires-Root: no

Package: obs-studio
Architecture: any
Depends:
 qt6-image-formats-plugins,
 qt6-wayland,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Recommends:
 obs-plugins (= ${binary:Version}),
Suggests:
 pkexec | policykit-1,
 v4l2loopback-dkms,
Breaks:
 obs-websocket (<< 4.9.0-2.1~),
Replaces:
 obs-websocket (<< 4.9.0-2.1~),
Description: recorder and streamer for live video content
 OBS Studio is designed for efficiently recording and streaming live video
 content. It supports live RTP streaming to various streaming sites.
 .
 Other features include:
  * Encoding using H264 (x264) and AAC
  * Unlimited number of scenes and sources
  * File output to MP4 or FLV
  * GPU-based game capture for high performance game streaming
  * Bilinear or lanczos3 resampling
 .
 Note that OBS Studio requires an OpenGL 3.2 compatible video card.

Package: obs-plugins
Architecture: any
Built-Using:
 ${simde:Built-Using},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 vlc,
Multi-Arch: same
Description: recorder and streamer for live video content (plugins)
 OBS Studio is designed for efficiently recording and streaming live
 video content. It supports live RTP streaming to various streaming sites.
 .
 This package contains some extra plugins (ALSA, JACK, PipeWire, DeckLink,
 VLC).

Package: libobs0t64
Provides:
 ${t64:Provides},
Replaces:
 libobs0,
Breaks:
 libobs0 (<< ${source:Version}),
Multi-Arch: same
Section: libs
Architecture: any
Built-Using:
 ${simde:Built-Using},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: recorder and streamer for live video content (shared library)
 OBS Studio is designed for efficiently recording and streaming live video
 content. It supports live RTP streaming to various streaming sites.
 .
 This package contains the shared library libobs.

Package: libobs-dev
Section: libdevel
Architecture: any
Depends:
 libobs0t64 (= ${binary:Version}),
 libsimde-dev,
 libx11-dev,
 ${misc:Depends},
Description: recorder and streamer for live video content (development files)
 OBS Studio is designed for efficiently recording and streaming live video
 content. It supports live RTP streaming to various streaming sites.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

CONFIG=None

export DEB_CPPFLAGS_MAINT_APPEND=-DFFMPEG_MUX_FIXED=\"/usr/lib/$(DEB_HOST_MULTIARCH)/obs-plugins/obs-ffmpeg/obs-ffmpeg-mux\"
deb_cflags+=-DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3 -fvisibility=hidden
deb_cflags+=-Wno-error=deprecated-declarations

confflags  =
confflags += -G Ninja
confflags += -DOBS_MULTIARCH_SUFFIX=/$(DEB_HOST_MULTIARCH)
confflags += -DOBS_VERSION_OVERRIDE=$(subst +dfsg,.1,$(DEB_VERSION))
confflags += -DAPPDATA_RELEASE_DATE=$(shell date --utc --date=@$${SOURCE_DATE_EPOCH} +'%Y-%m-%d')
confflags += -DUNIX_STRUCTURE=TRUE
confflags += -DCMAKE_SKIP_RPATH=TRUE
confflags += -DDISABLE_UPDATE_MODULE=TRUE
confflags += -DBUILD_TESTS=TRUE -DENABLE_UNIT_TESTS=TRUE
confflags += -DENABLE_AJA=FALSE
confflags += -DENABLE_JACK=TRUE
confflags += -DENABLE_PIPEWIRE=TRUE
confflags += -DENABLE_SNDIO=FALSE
confflags += -DENABLE_VST=FALSE
confflags += -DENABLE_WEBRTC=FALSE

ifeq ($(DEB_HOST_ARCH_CPU), i386)
confflags += -DENABLE_SIMD=FALSE
deb_cflags+=-Wno-error=psabi
endif
DEB_CFLAGS_MAINT_APPEND+=$(deb_cflags)
DEB_CPPFLAGS_MAINT_APPEND+=$(deb_cflags)


BUILDDIR=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)
%:
	dh $@ --builddirectory=$(BUILDDIR)

execute_before_dh_auto_configure:
	cp -r websocket plugins/obs-websocket
	mkdir -p plugins/obs-websocket/deps
	cp -r debian/extra/qr plugins/obs-websocket/deps/
	-find plugins/obs-websocket/ -name ".git*" -exec rm -rf {} +
override_dh_auto_configure:
	dh_auto_configure -- $(confflags)

execute_before_dh_auto_build:
	@echo 'blhc: ignore-line-regexp: .* -c /usr/share/cmake-[0-9.]*/Modules/CMakeCXXCompilerABI\.cpp .*'

execute_after_dh_auto_build:
	rst2man debian/obs.rst > debian/obs.1


override_dh_auto_test:
	LD_LIBRARY_PATH=$(BUILDDIR)/rundir/$(CONFIG)/lib/$(DEB_HOST_MULTIARCH) dh_auto_test

execute_after_dh_auto_install:
	-find debian/tmp -type f -name "*.pem" -exec chmod a-x {} +
	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/obs-plugins/obs-ffmpeg
	mv debian/tmp/usr/bin/obs-ffmpeg-mux \
		debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/obs-plugins/obs-ffmpeg/obs-ffmpeg-mux
execute_after_dh_install:
	rm -rf debian/obs-studio/usr/share/obs/obs-studio/license

execute_before_dh_shlibdeps:
	echo "libobs 0 libobs0t64 (= $(DEB_VERSION))" > debian/shlibs.local

override_dh_python3:
	dh_python3 -p obs-studio usr/share/obs/obs-plugins/frontend-tools/scripts
	dh_python3 -p obs-studio usr/lib/$(DEB_HOST_MULTIARCH)/obs-scripting

override_dh_gencontrol:
	dh_gencontrol -- -Vsimde:Built-Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W "libsimde-dev")"

################################################################
DEB_COPYRIGHT_CHECK_IGNORE_REGEX = \
	debian/.*|.*\.ttf|.*\.png|cmake/macos/resources/AppIcon.icns|cmake/macos/resources/background.tiff|UI/cmake/windows/obs-studio\.ico
# licensecheck v1
.PHONY: licensecheck
licensecheck:
	LANG=C.UTF-8 licensecheck \
		-i "^($(DEB_COPYRIGHT_CHECK_IGNORE_REGEX))$$" \
		--check '.*' --recursive --deb-machine --lines 0 * \
		> debian/copyright_newhints
	cmp debian/copyright_hints debian/copyright_newhints \
		&& rm debian/copyright_newhints

=== debian/tests/control ===
Test-Command: obs --version && obs --help
Depends:
 obs-studio,
Restrictions: superficial
Features: test-name=version-and-help-output

=== debian/watch ===
#version=4
#opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%obs-studio-$1.tar.gz%,dversionmangle=s%\+dfsg\d*$%%,repacksuffix=+dfsg1" \
#https://github.com/jp9000/obs-studio/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz

version=4
# check: uscan --report
# update: gbp import-orig --upstream-vcs-tag=vX.Y.Z --uscan

opts=\
  filenamemangle=s/.*?(@ANY_VERSION@@ARCHIVE_EXT@)/@PACKAGE@-$1/,\
  repacksuffix=+dfsg,\
  uversionmangle=s/-?(alpha|beta|rc)/~$1/,\
  dversionmangle=auto \
	https://github.com/obsproject/obs-studio/tags \
	.*?@ANY_VERSION@@ARCHIVE_EXT@

## ouch, this will just import the latest (tagged) version of obs-websocket,
# not necessarily the one that obs-studio included via .gitmodules
# one solution would be https://github.com/obsproject/obs-studio/issues/7407,
# another one to somehow parse the submodule SHA1 and use that,
# a third one to switch to git rather than upstream tarballs.
# for now, use this and pray.
opts=\
  filenamemangle=s/.*?(@ANY_VERSION@@ARCHIVE_EXT@)/@PACKAGE@-$1/,\
  component=websocket,\
  repacksuffix=+dfsg,\
  dversionmangle=auto \
	https://github.com/obsproject/obs-websocket/tags \
	.*?@ANY_VERSION@@ARCHIVE_EXT@ ignore
